function  varargout = acquiobli(varargin)
%UNTITLED Summary of this function goes here
%   Detailed explanation goes here

warning off 
warning off MATLAB:uitabgroup:OldVersion
addpath lib

%%Estructura per mantenir les dades a analitzar
% Matriu a analitzar amb tots els items 
data.X=[];
% Matriu a analitzar nomes amb els items a analitzar 
data.Xa=[];
% Index d'items de contingut
data.ItemsContent=[];
% Index d'items inclosos
data.ItemsIn=[];
% Index d'items exclosos
data.ItemsEx=[];
% Index d'items markers
data.ItemsMarkers=[];
% Index d'items de contingut
data.ItemsContent=[];
% Index d'items de contingut revertits
data.ItemsRevertits=[];
%Etiquetes dels items;
data.LabelsItemsString=[];
data.LabelsItems=[];
%Index dels items de contingut revertits segons la seva posici a l'anlisi entre els items de contingut
data.rev=[];
%DATAFILE that is analysed
data.filename='';
 
% Matriu a analitzar 
data.R=[];
% Patr factorial
data.P=[];

%Per defecte, la matriu es considera positiu definida
data.R_NPD = 0;
% Per defecte, el model �s el lineal
data.IRTModel=1;

%Set the letter for the menus
data.font = ChooseFont('Helvetica','Arial','MS Sans Serif');

% Que estigui disponble en qualsavol moment
setappdata(0,'data',data);

finestra.N=760;
finestra.M=600;
pantalla=get(0,'ScreenSize');
finestra.coordenades=[(pantalla(3)/2)-(finestra.N/2)  (pantalla(4)/2)-(finestra.M/2) finestra.N finestra.M];

%Crear figura
handles.fig = figure('Units','Pixels',...
    'color' , [0.941 0.941 0.941],...
    'Position',finestra.coordenades);
tmp=get(0,'FactoryUIControlBackgroundColor');
set(handles.fig, 'MenuBar','none','Name','AcquiObli','Toolbar','none','NumberTitle','off','resize','off');

%%%%%Crear MENUS
%Menu File
handles.MenuFile = uimenu('Label','File');
handles.MenuFile_ImportDataAdvanced = uimenu(handles.MenuFile,...
                                'Label','Read data file');
handles.MenuFile_ClearData = uimenu(handles.MenuFile,...
                                'Label','Clear data');
handles.MenuFile_OpenMatFiles = uimenu(handles.MenuFile,...
                                'Label','Open a Matlab file (*.mat)',...
                                'Separator','on');
handles.MenuFile_Save = uimenu(handles.MenuFile,...
                                'Label','Save data as a Matlab file (*.mat)');
handles.MenuFile_Quit = uimenu(handles.MenuFile,...
                                'Label','Quit',...
                                'Separator','on');
%Menu Help
handles.MenuHelp = uimenu('Label','Help');
handles.MenuHelp_About = uimenu(handles.MenuHelp,...
                                'Label','About AcquiObli');
handles.MenuHelp_Help = uimenu(handles.MenuHelp,...
                                'Label','Help');

                            
%%Agrupacio
%handles.hTabGroup = uitabgroup('parent',handles.fig,...
%    'BackgroundColor', [.941 .941 .941]);
handles.hTabGroup = uitabgroup('parent',handles.fig);

%%ABOUT PANEL
tab0 = uitab(handles.hTabGroup,'title','About AquiObli','Units','pixels');
handles.panel_tab0=uipanel('parent',tab0,'Units','pixels','BackgroundColor', [.784 .949 .98]);

[logo.img]=imread('bivariate.png');
 logo.axes = axes('parent',handles.panel_tab0,...
    'Position',[0.2 0.15 0.6 0.6],...
    'XGrid','off',...
     'YGrid','off',...
     'Layer','top');
%    'Position',[0.2 0.2 0.6 0.6],...

image(logo.img, 'Parent', logo.axes);
axis(logo.axes,'image','off');

%TEXT DE PORTADA
handles.text0_1= uicontrol(handles.panel_tab0,'Style','text',...
    'Units','pixels',...
    'position',[275 500 400 50],...
    'fontname',char(data.font),...
    'FontSize',20,...
    'ForegroundColor',[.6 .2 0],...
    'HorizontalAlignment','left',...
    'BackgroundColor', [.784 .949 .98],...
    'String','A C Q U I O B L I');  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%MEJORAR
handles.text0_2= uicontrol(handles.panel_tab0,'Style','text',...
    'Units','pixels',...
    'position',[190 460 400 50],...
    'fontname',char(data.font),...
    'FontSize',14,...
    'ForegroundColor',[.6 .2 0],...
    'HorizontalAlignment','left',...
    'BackgroundColor', [.784 .949 .98],...
    'String','Urbano Lorenzo-Seva    &    Pere J. Ferrando');
handles.text0_3= uicontrol(handles.panel_tab0,'Style','text',...
    'Units','pixels',...
    'position',[260 465 400 20],...
    'fontname',char(data.font),...
    'FontSize',12,...
    'ForegroundColor',[.6 .2 0],...
    'HorizontalAlignment','left',...
    'BackgroundColor', [.784 .949 .98],...
    'String','Release Version 1.02,  January  2016');
handles.text0_5= uicontrol(handles.panel_tab0,'Style','text',...
    'Units','pixels',...
    'position',[260 40 400 20],...
    'fontname',char(data.font),...
    'FontSize',12,...
    'ForegroundColor',[.6 .2 0],...
    'HorizontalAlignment','left',...
    'BackgroundColor', [.784 .949 .98],...
    'String','Research Center for Behavior Assessment');
handles.text0_6= uicontrol(handles.panel_tab0,'Style','text',...
    'Units','pixels',...
    'position',[250 10 400 20],...
    'fontname',char(data.font),...
    'FontSize',12,...
    'ForegroundColor',[.6 .2 0],...
    'HorizontalAlignment','left',...
    'BackgroundColor', [.784 .949 .98],...
    'String','Universitat Rovira i Virgili, Tarragona (Spain)');

ha = axes('Parent',handles.panel_tab0,'Visible','off');
ht = text('Parent',ha, ...
    'String','Content factor scores', ...
    'fontname',char(data.font),...
    'Units','pixels',...
    'position',[80 45 ],...
    'FontSize',12,...    
    'Rotation',0);

ha = axes('Parent',handles.panel_tab0,'Visible','off');
ht = text('Parent',ha, ...
    'String','Acquiescence factor scores', ...
    'fontname',char(data.font),...
    'Units','pixels',...
    'position',[440 65 ],...
    'FontSize',12,...    
    'Rotation',73);

%%DATA PANEL
tab1 = uitab(handles.hTabGroup,'title','Configure your data','Units','pixels');
handles.panel_tab1=uipanel('parent',tab1,'Units','pixels','BackgroundColor', [.941 .941 .941]);

%ETIQUETA DE LA MATRIU DE DADES
handles.text1= uicontrol(handles.panel_tab1,'Style','text',...
    'Units','pixels',...
    'position',[10 540 700 20],...
    'fontname',char(data.font),...
    'FontSize',13,...
    'ForegroundColor',[.6 .2 0],...
    'HorizontalAlignment','left',...
    'BackgroundColor', [.941 .941 .941],...
    'String','Data matrix:');

A={'Load or import a file data from menu "File"'};
handles.DataTable=uitable(handles.panel_tab1,'units','pixels','position',[15 220 730 310], 'Data', A);
handles.DataAvailable=0;

%ETIQUETA DELS MARCADORS
handles.text2= uicontrol(handles.panel_tab1,'Style','text',...
    'Units','pixels',...
    'position',[10 110 200 20],...
    'fontname',char(data.font),...
    'FontSize',12,...
    'ForegroundColor',[.6 .2 0],...
    'HorizontalAlignment','left',...
    'BackgroundColor', [.941 .941 .941],...
    'String','Markers of acquiescence: ');

%ETIQUETA DE LEXEMPLE DELS MARCADORS
handles.text3= uicontrol(handles.panel_tab1,'Style','text',...
    'Units','pixels',...
    'position',[210 80 500 20],...
    'fontname',char(data.font),...
    'FontSize',10,...
    'ForegroundColor',[.6 .2 0],...
    'HorizontalAlignment','left',...
    'BackgroundColor', [.941 .941 .941],...
    'String','Enter item numbers separated by a coma. For example: 1, 3, 6');

%QUADRE EDITABLE DELS MARCADORS
handles.Marcadors= uicontrol(handles.panel_tab1,'Style','edit',...
    'Units','pixels',...
    'position',[210 105 532 25],...
    'FontSize',12,...
    'fontname','courier',...
    'TooltipString','Write here your matlab commands',...
    'max',0,...  
    'BackgroundColor',[1 1 1],...
    'ForegroundColor',[0 0 0],...  
    'Enable','off',...
    'HorizontalAlignment','left',...
    'String','');

%ETIQUETA DELS ITEMS REVERTITS
handles.text4= uicontrol(handles.panel_tab1,'Style','text',...
    'Units','pixels',...
    'position',[10 40 200 20],...
    'fontname',char(data.font),...
    'FontSize',12,...
    'ForegroundColor',[.6 .2 0],...
    'HorizontalAlignment','left',...
    'BackgroundColor', [.941 .941 .941],...
    'String','Items that are reversed: ');

%ETIQUETA DE LEXEMPLE DELS ITEMS
handles.text5= uicontrol(handles.panel_tab1,'Style','text',...
    'Units','pixels',...
    'position',[210 10 500 20],...
    'fontname',char(data.font),...
    'FontSize',10,...
    'ForegroundColor',[.6 .2 0],...
    'HorizontalAlignment','left',...
    'BackgroundColor', [.941 .941 .941],...
    'String','Enter item numbers separated by a coma. For example: 2, 7');

%QUADRE EDITABLE DELS REVERTITS
handles.Revertits= uicontrol(handles.panel_tab1,'Style','edit',...
    'Units','pixels',...
    'position',[210 35 532 25],...
    'FontSize',12,...
    'fontname','courier',...
    'TooltipString','Write here your matlab commands',...
    'max',0,...  
    'BackgroundColor',[1 1 1],...
    'ForegroundColor',[0 0 0],...  
    'Enable','off',...
    'HorizontalAlignment','left',...
    'String','');

%ETIQUETA DELS EXCLOSOS
handles.text6= uicontrol(handles.panel_tab1,'Style','text',...
    'Units','pixels',...
    'position',[10 185 200 20],...
    'fontname',char(data.font),...
    'FontSize',12,...
    'ForegroundColor',[.6 .2 0],...
    'HorizontalAlignment','left',...
    'BackgroundColor', [.941 .941 .941],...
    'String','Items to be excluded: ');

%ETIQUETA DE LEXEMPLE DELS EXCLOSOS
handles.text7= uicontrol(handles.panel_tab1,'Style','text',...
    'Units','pixels',...
    'position',[210 155 500 20],...
    'fontname',char(data.font),...
    'FontSize',10,...
    'ForegroundColor',[.6 .2 0],...
    'HorizontalAlignment','left',...
    'BackgroundColor', [.941 .941 .941],...
    'String','Enter item numbers separated by a coma. For example: 3, 6');

%QUADRE EDITABLE DELS EXCLOSOS
handles.Exclosos= uicontrol(handles.panel_tab1,'Style','edit',...
    'Units','pixels',...
    'position',[210 180 532 25],...
    'FontSize',12,...
    'fontname','courier',...
    'TooltipString','Write here your matlab commands',...
    'max',0,...  
    'BackgroundColor',[1 1 1],...
    'ForegroundColor',[0 0 0],...  
    'Enable','off',...
    'HorizontalAlignment','left',...
    'String','');

%%%%%%%%%%%%%%%%%%%%MODEL FIT TAB & PANEL
tab2 = uitab(handles.hTabGroup,'title',' Configure the analysis ','Units','pixels');
handles.panel_tab2=uipanel('parent',tab2,'Units','pixels','BackgroundColor', [.941 .941 .941]);

%%No esta visible fins que es carregen dades
set(handles.panel_tab2,'visible','off');

%ETIQUETA DEL QUADRE DEL MODEL A AJUSTAR
handles.text8= uicontrol(handles.panel_tab2,'Style','text',...
    'Units','pixels',...
    'position',[15 540 200 20],...
    'fontname',char(data.font),...
    'FontSize',13,...
    'ForegroundColor',[.6 .2 0],...
    'HorizontalAlignment','left',...
    'BackgroundColor', [.941 .941 .941],...
    'String','Factor Analysis Model');

%SUBPANEL DEL MODELO A AJUSTAR 
handles.panel_model=uipanel('parent',handles.panel_tab2,'Units','pixels',...
    'BackgroundColor', [.941 .941 .941],...
    'position',[15 250 725 280]);

%Radio button: model linear
handles.Model_Linear = uicontrol('parent',handles.panel_model,...
    'style','radiobutton',...
    'string','Linear model',...
    'fontname',char(data.font),...
    'FontSize',13,...
    'ForegroundColor',[.6 .2 0],...
    'HorizontalAlignment','left',...
    'value',1,...
    'BackgroundColor', [.941 .941 .941],...
    'position',[15 250 700 20]);

%MATLAB Model linear explanation
ModelExplanation={};
ModelExplanation(1)=cellstr('Items are considered as continous measures. The dispersion matrix that is');
ModelExplanation(2)=cellstr('analyzed is the Pearson correlation matrix. ');
handles.ModelTextLinear= uicontrol(handles.panel_model,'Style','listbox',...
    'Units','pixels',...
    'position',[35 195 675 50],...
    'FontSize',12,...
    'fontname',char(data.font),...
    'BackgroundColor',[1 1 1],...
    'ForegroundColor',[0 0 0],...  
    'HorizontalAlignment','left',...
    'min',0,'max',0,...
    'FontWeight','normal',...
    'String',ModelExplanation);

%Radio button: model Two Parameters
handles.Model_TwoParameters = uicontrol('parent',handles.panel_model,...
    'style','radiobutton',...
    'string','Two-parameter model',...
    'fontname',char(data.font),...
    'FontSize',13,...
    'ForegroundColor',[.6 .2 0],...
    'HorizontalAlignment','left',...
    'value',0,...
    'BackgroundColor', [.941 .941 .941],...
    'position',[15 165 700 20]);

%MATLAB Model two parameters model
ModelExplanation={};
ModelExplanation(1)=cellstr('Items are dichotomous. The dispersion matrix that is analyzed is the tetrachoric');
ModelExplanation(2)=cellstr('correlation matrix. ');
handles.ModelTextTwoParameters= uicontrol(handles.panel_model,'Style','listbox',...
    'Units','pixels',...
    'position',[35 110 675 50],...
    'FontSize',12,...
    'fontname',char(data.font),...
    'BackgroundColor',[1 1 1],...
    'ForegroundColor',[0 0 0],...  
    'HorizontalAlignment','left',...
    'min',0,'max',0,...
    'FontWeight','normal',...
    'String',ModelExplanation);

%Radio button: model Two Parameters
handles.Model_GradedModel = uicontrol('parent',handles.panel_model,...
    'style','radiobutton',...
    'string','Graded response model',...
    'fontname',char(data.font),...
    'FontSize',13,...
    'ForegroundColor',[.6 .2 0],...
    'HorizontalAlignment','left',...
    'value',0,...
    'BackgroundColor', [.941 .941 .941],...
    'position',[15 80 700 20]);

%MATLAB Model graded response model
ModelExplanation={};
ModelExplanation(1)=cellstr('Item responses are ordered-categorical. The dispersion matrix is the polychoric');
ModelExplanation(2)=cellstr('correlation matrix. This model is Samejimas''s graded response model. All the');
ModelExplanation(3)=cellstr('items must have the same number of response categories.');
handles.ModelTextGradedModel= uicontrol(handles.panel_model,'Style','listbox',...
    'Units','pixels',...
    'position',[35 10 675 65],...
    'FontSize',12,...
    'fontname',char(data.font),...
    'BackgroundColor',[1 1 1],...
    'ForegroundColor',[0 0 0],...  
    'HorizontalAlignment','left',...
    'min',0,'max',0,...
    'FontWeight','normal',...
    'String',ModelExplanation);


%ETIQUETA DEL QUADRE DEL NOMBRE DE VARIABLES LATENTS
handles.text9= uicontrol(handles.panel_tab2,'Style','text',...
    'Units','pixels',...
    'position',[15 220 400 20],...
    'fontname',char(data.font),...
    'FontSize',13,...
    'ForegroundColor',[.6 .2 0],...
    'HorizontalAlignment','left',...
    'BackgroundColor', [.941 .941 .941],...
    'String','Configuration of output');

%SUBPANEL DE LA CONFIGURACIO DELS FACTORS
handles.panel_configure_output=uipanel('parent',handles.panel_tab2,'Units','pixels',...
    'BackgroundColor', [.941 .941 .941],...
    'position',[15 60 725 150]);

%ETIQUETA BOOTSTRAP
handles.Bootstrap= uicontrol(handles.panel_configure_output,'style','checkbox',...
    'Units','pixels',...
    'position',[15 110 500 20],...
    'fontname',char(data.font),...
    'FontSize',12,...
    'ForegroundColor',[.6 .2 0],...
    'HorizontalAlignment','left',...
    'visible','on',...
    'value',0,...
    'BackgroundColor', [.941 .941 .941],...
    'String','Compute Bootstrap 90% confidence intervals for loading values.');

handles.FactorScores= uicontrol(handles.panel_configure_output,'style','checkbox',...
    'Units','pixels',...
    'position',[15 70 500 20],...
    'fontname',char(data.font),...
    'FontSize',12,...
    'ForegroundColor',[.6 .2 0],...
    'HorizontalAlignment','left',...
    'visible','on',...
    'value',0,...
    'BackgroundColor', [.941 .941 .941],...
    'String','Compute individuals'' factor scores.');

%BOTON COMPUTE PER CALCULAR EL MODEL I ELS PERSON FIT INDICES
handles.ButtonCompute = uicontrol(handles.panel_tab2,'String',' Compute ',...
    'Style','pushbutton',...
    'Enable','on',...
    'FontSize',13,...
    'fontname',char(data.font),...   
    'position',[640 10 100 30],...
    'BackgroundColor', [.831 .816 .784],...
    'ForegroundColor',[.6 .2 0]);

%%%%%%%%%%%%%%%%%%%%MODEL FIT TAB & PANEL
tab3 = uitab(handles.hTabGroup,'title',' Output ','Units','pixels');
handles.panel_tab3=uipanel('parent',tab3,'Units','pixels','BackgroundColor', [.941 .941 .941]);
   
%%No esta visible fins que es fan calculs 
set(handles.panel_tab3,'visible','off');

%ETIQUETA DEL QUADRE DE OUTPUT DEL MODELO
handles.text13= uicontrol(handles.panel_tab3,'Style','text',...
    'Units','pixels',...
    'position',[10 540 700 20],...
    'fontname',char(data.font),...
    'FontSize',13,...
    'ForegroundColor',[.6 .2 0],...
    'HorizontalAlignment','left',...
    'BackgroundColor', [.941 .941 .941],...
    'String','Model fit: output');
 
tmp={};
global OuputLetter;
OuputLetter = 12;
handles.ModelOutput= uicontrol(handles.panel_tab3,'Style','listbox',...
    'Units','pixels',...
    'position',[10 80 735 450],...
    'FontSize',OuputLetter,...
    'fontname','courier',...
    'BackgroundColor',[1 1 1],...
    'ForegroundColor',[0 0 0],...  
    'HorizontalAlignment','left',...
    'min',0,'max',0,...
    'FontWeight','normal',...
    'String',tmp);

handles.ModelOutputDecrementa= uicontrol(handles.panel_tab3,'string','-',...
    'Style','pushbutton',...
    'Units','pixels',...
    'position',[675 533 30 30],...
    'FontSize',13,...
    'fontname',char(data.font),...
    'TooltipString','Zoom out',...
    'BackgroundColor', [.831 .816 .784],...
    'ForegroundColor',[.6 .2 0],...  
    'HorizontalAlignment','center',...
    'FontWeight','normal');

handles.ModelOutputIncrementa= uicontrol(handles.panel_tab3,'string','+',...
    'Style','pushbutton',...
    'Units','pixels',...
    'position',[714 533 30 30],...
    'FontSize',13,...
    'fontname',char(data.font),...
    'TooltipString','Zoom in',...
    'BackgroundColor', [.831 .816 .784],...
    'ForegroundColor',[.6 .2 0],...  
    'HorizontalAlignment','center',...
    'FontWeight','normal');

%BOTON SALVAR L'OUTPUT A UN FITXER TEXT
handles.ButtonSalvarOutput = uicontrol(handles.panel_tab3,'String',' Save output ',...
    'Style','pushbutton',...
    'Enable','on',...
    'FontSize',13,...
    'fontname',char(data.font),...   
    'position',[10 10 200 30],...
    'TooltipString','To save the output of the fitted model as a text file',...
    'BackgroundColor', [.831 .816 .784],...
    'ForegroundColor',[.6 .2 0]);

%BOTON SALVAR MODEL A UN FITXER MATLAB
handles.ButtonSalvarModel = uicontrol(handles.panel_tab3,'String',' Save model ',...
    'Style','pushbutton',...
    'Enable','on',...
    'FontSize',13,...
    'Visible','off',...
    'fontname',char(data.font),...   
    'position',[430 10 200 30],...
    'TooltipString','To save the model parameters to be used in the applied psychometrician module',...    
    'BackgroundColor', [.831 .816 .784],...
    'ForegroundColor',[.6 .2 0]);

%%CALLBACKS TAB MODELO
set(handles.Model_Linear,...
    'Callback',{@ModelRadius_Callback ,handles,1}); 
set(handles.Model_TwoParameters,...
    'Callback',{@ModelRadius_Callback ,handles,2}); 
set(handles.Model_GradedModel,...
    'Callback',{@ModelRadius_Callback ,handles,3}); 
set(handles.ButtonCompute,...
    'Callback',{@ButtonCompute_Callback,handles});

%%CALLBACKS TAB FIT OF MODELO
set(handles.ModelOutputDecrementa,...
    'Callback',{@ModelOutputDecrementa_Callback, handles, 1});
set(handles.ModelOutputIncrementa,...
    'Callback',{@ModelOutputDecrementa_Callback, handles, 2});
set(handles.ButtonSalvarOutput,...
    'Callback',{@ButtonSalvarOutput_Callback,handles});
                            
                            
%%CALLBACKS MENUS: FILE
set(handles.MenuFile_OpenMatFiles,...
    'Callback',{@Load_Callback ,handles});
set(handles.MenuFile_ImportDataAdvanced,...
    'Callback',{@AdvancedImport_Callback ,handles}); 

set(handles.MenuFile_Save,...
    'Callback',{@Save_Callback ,handles}); 
set(handles.MenuFile_ClearData,...
    'Callback',{@ClearData_Callback ,handles});
set(handles.MenuFile_Quit,...
    'Callback',{@Quit_Callback ,handles}); 
%%CALLBACKS MENUS: HELP
set(handles.MenuHelp_About,...
    'Callback',{@About_Callback ,handles}); 
set(handles.MenuHelp_Help,...
    'Callback',{@Help_Callback ,handles}); 

drawnow;


return;

%%%%FUNCTIONS OF MENUS
function Load_Callback(hObject, eventdata, handles)

	try       
        evalin('base','clear');
        evalin('base','uiopen(''load'')');
        evalin('base','clc');

        f = evalin('base','exist(''ACQUIOBLI_DATA_INTERNALUSE'')');
        
        if (f==1) ,
                %evalin('base','data=getappdata(0,''data'');');
                evalin('base','data.X = ACQUIOBLI_DATA_INTERNALUSE;');
                evalin('base','setappdata(0,''data'',data)');
                evalin('base','clear data;');
                                
                data=getappdata(0,'data');
                str1 ={'set(handles.DataTable,''Data'', data.X);'};
                eval(char(str1));

                tmp = sprintf('Data matrix: %s',data.filename);
                set(handles.text1,'string',tmp);   
                
                handles.DataAvailable=1;      
                set(handles.Model_Linear,'value',1);
                set(handles.Bootstrap,'value',0);            
                set(handles.FactorScores,'value',0);            
                set(handles.Model_TwoParameters,'value',0);
                set(handles.Model_GradedModel,'value',0);
                set(handles.panel_tab2,'visible','on');
                set(handles.Marcadors,'enable','on');            
                set(handles.Revertits,'enable','on');            
                set(handles.Exclosos,'enable','on');            
                set(handles.Marcadors,'string',data.Marcadors);            
                set(handles.Revertits,'string',data.Revertits);            
                set(handles.Exclosos,'string',data.Exclosos);            
                
                drawnow;

                %LOAD DATA
                data=getappdata(0,'data');
                data.Xa=[];
                data.ItemsIn=[];
                data.ItemsEx=[];
                data.IRTModel=1;
                data.ItemsContent=[];
                data.ItemsMarkers=[];
                data.ItemsContent=[];
                data.ItemsRevertits=[];
                data.LabelsItemsString=[];
                data.LabelsItems=[];
                data.rev=[];
                %SAVE DATA 
                setappdata(0,'data',data);

                evalin('base','clc');
            
        else,
            msgbox('The file is empty or it was not created with ACQUIOBLI software','AcquiObli','error');
            A={'Load or import a file data from menu "File"'};
            handles.DataTable=set(handles.DataTable, 'Data', A);
            handles.DataAvailable=0;
            set(handles.panel_tab2,'visible','off');
            set(handles.panel_tab3,'visible','off');
            set(handles.Marcadors,'enable','off');            
            set(handles.Revertits,'enable','off');            
            set(handles.Exclosos,'enable','off');            
            set(handles.Marcadors,'string','');            
            set(handles.Revertits,'string','');            
            set(handles.Exclosos,'string','');            
            set(handles.Bootstrap,'value',0);

            return;    
        end;
	catch
		errordlg(lasterr,'error');
    end
return;
% --------------------------------------------------------------------
function AdvancedImport_Callback(hObject, eventdata, handles)
% hObject    handle to OpenAscii (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
    try 
        
       [filename, path] = uigetfile( ...
        {'*.dat',  'ASCII data files (*.dat)'; ...
        '*.txt',  'ASCII text files (*.txt)'; ...
        '*.mat','MAT-files (*.mat)'; ...
        '*.*',  'All Files (*.*)'}, ...
        'Select a file with the data to be imported');
    
        file = sprintf('%s%s',path,filename);
        [tmp1,tmp2]=size(file);
        if tmp2 == 2,
            return;  %Canceled
        end;
        tmp = uiimport(file); % directly imports the selected file
        if isempty(tmp),
            return;  %Canceled
        end;

        %UPDAT THE LIST OF AVAILABLE VARIABLES
        evalin('base','clear');
        
        str = fieldnames(tmp,'-full');
        [h,tmp2]=size(str);        
        for i=1:h,
            buff = ['global ' char(str{i})];
            eval(buff);    
            evalin('base',buff);    
            buff = ['eval (''' char(str{i}) ' = tmp.' char(str{i}) ';'');'];
            eval(buff);
        end;

        %UPDAT THE LIST OF AVAILABLE VARIABLES
        evalin('base','clear ans');
        evalin('base','clc');
        vars = evalin('base','who');
        
        %DATA IS ALWAYS IN "ACQUIOBLI_DATA_INTERNALUSE"
        str1 ={'ACQUIOBLI_DATA_INTERNALUSE = '};
        str3 ={';'};
        str4 = char(strcat(str1,vars,str3));
        evalin('base',str4);
 
        evalin('base','data=getappdata(0,''data'');');
        evalin('base','data.X = ACQUIOBLI_DATA_INTERNALUSE;');
        evalin('base','setappdata(0,''data'',data)');
        evalin('base','clear data;');
        
        str1 ={'set(handles.DataTable,''Data'', '};
        str3 ={');'};
        str4 = char(strcat(str1,vars,str3));
        eval(str4);
        
        str1 ={'clear '};
        str3 ={';'};
        str4 = char(strcat(str1,vars,str3));
        evalin('base',str4);
        
        handles.DataAvailable=1;
        set(handles.Model_Linear,'value',1);
        set(handles.Bootstrap,'value',0);            
        set(handles.FactorScores,'value',0);            
        set(handles.Model_TwoParameters,'value',0);
        set(handles.Model_GradedModel,'value',0);
        set(handles.panel_tab2,'visible','on');
        set(handles.panel_tab3,'visible','off');
        set(handles.Marcadors,'enable','on');            
        set(handles.Revertits,'enable','on');            
        set(handles.Exclosos,'enable','on');            
        set(handles.Marcadors,'string','');            
        set(handles.Revertits,'string','');            
        set(handles.Exclosos,'string','');            
        set(handles.Bootstrap,'value',0);

        tmp = sprintf('Data matrix: %s',file);
        set(handles.text1,'string',tmp);   
        
        %save datafile
        data=getappdata(0,'data');
        data.filename = file;
        setappdata(0,'data',data);
        
        drawnow;
    catch
 		errordlg(lasterr,'error');
    end     
return;
% --------------------------------------------------------------------
function Save_Callback(hObject, eventdata, handles)
% hObject    handle to Save (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

    data=getappdata(0,'data');
    data.Exclosos = get(handles.Exclosos,'string');
    data.Marcadors = get(handles.Marcadors,'string');
    data.Revertits = get(handles.Revertits,'string');
    setappdata(0,'data',data);
	try
       evalin('base','data=getappdata(0,''data'');');
       evalin('base','uisave({''ACQUIOBLI_DATA_INTERNALUSE'', ''data''})');
       evalin('base','clear data;');
	catch
		errordlg(lasterr,'error');
	end
return;
% --------------------------------------------------------------------
function ClearData_Callback(hObject, eventdata, handles)
% hObject    handle to ClearData (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
    ButtonName=questdlg('Do you want to clear the data in memory','AcquiObli'); 
    switch ButtonName
    case {'No','Cancel'}
	    % take no action
    case 'Yes'
        evalin('base','clear');
        evalin('base','clc');
        A={'Load or import a file data from menu "File"'};
        set(handles.DataTable, 'Data', A);
        handles.DataAvailable=0;
        set(handles.panel_tab2,'visible','off');
        set(handles.panel_tab3,'visible','off');
        set(handles.Marcadors,'enable','off');            
        set(handles.Revertits,'enable','off');            
        set(handles.Exclosos,'enable','off');            
        set(handles.Marcadors,'string','');            
        set(handles.Revertits,'string','');            
        set(handles.Exclosos,'string','');            
        set(handles.Marcadors, 'BackgroundColor',[1 1 1],'ForegroundColor',[0 0 0]);
        set(handles.Exclosos, 'BackgroundColor',[1 1 1],'ForegroundColor',[0 0 0]);
        set(handles.Revertits, 'BackgroundColor',[1 1 1],'ForegroundColor',[0 0 0]);
        set(handles.Bootstrap,'value',0);
        set(handles.text1,'string','Data matrix: ');   
        
        %LOAD DATA
        data=getappdata(0,'data');
        data.X=[];
        data.Xa=[];
        data.ItemsIn=[];
        data.ItemsEx=[];
        data.IRTModel=1;
        data.ItemsContent=[];
        data.ItemsMarkers=[];
        data.ItemsContent=[];
        data.ItemsRevertits=[];
        data.LabelsItemsString=[];
        data.LabelsItems=[];
        data.rev=[];
        data.filename='';
        
        %SAVE DATA 
        setappdata(0,'data',data);

        evalin('base','clc');
        drawnow;
    end   
    
return;
% --------------------------------------------------------------------
function Quit_Callback(hObject, eventdata, handles)
% hObject    handle to quit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
    ButtonName=questdlg('Do you want to quit the application','Regression Person Fit'); 
    switch ButtonName
    case {'No','Cancel'}
	    % take no action
    case 'Yes'
        delete(gcbf);
    end    
return;
% --------------------------------------------------------------------
function Help_Callback(hObject, eventdata, handles)
% hObject    handle to HelpMenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
    web('psico.fcep.urv.cat\utilitats\AcquiObli','-notoolbar');
return;
% --------------------------------------------------------------------
function About_Callback(hObject, eventdata, handles)
% hObject    handle to AboutMCar (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
     Data=64:-1:1;Data=(Data'*Data)/64;
     h=msgbox('AcquiOblique (version: 1.02)                                         Urbano Lorenzo-Seva & Pere J. Ferrando                                  (Rovira i Virgili University, Tarragona, Spain)                      2016 ','About AcquiObli','custom',Data,hot(64));

return;
% --------------------------------------------------------------------
function output=ClearFields(str)
 
      strclean={};
      strclean='';
      
      c=char(str);
      [tmp,v]=size(c);
      
      for i=1:v,
          if c(i) ~= '.',
             strclean=strcat(strclean,c(i));
          else
              output=strclean;
              return;
          end;
      end;
      
      output=strclean;
      return;
function ButtonSalvarOutput_Callback(hObject, eventdata, handles)

[FILENAME, PATHNAME] = uiputfile({'*.txt','Text files'}, 'RegressionPersonFit: Save output as a text file');

if FILENAME == 0,
    return;
end;

try 

    FileDiary=[PATHNAME FILENAME];
    f=exist(FileDiary,'file');
    if f == 2,
       eval(['delete ' FileDiary]);
    end;
    
    eval(['diary ' FileDiary]);

    buff = get(handles.ModelOutput,'string');
%  Manera rpida    
%    disp(char(buff));
%
%  Aquesta s molt ms lent, per informa de com va
%
     [m,tmp]=size(buff);
     bar1 = waitbar(0,'Saving');
     for i=1:m,
         buffi= char(buff(i));
         if isempty(buffi),
             disp(' ');
         else,
            disp(char(buff(i)));
         end;
         waitbar(i/m,bar1);
     end;
    diary off;
    clc;
    close(bar1);
    
catch 
    errordlg(lasterr,'error');
end;

return
function ModelOutputDecrementa_Callback(hObject, eventdata, handles, accion)
global OuputLetter;

switch accion
    case 1
      if OuputLetter > 7, 
         OuputLetter = OuputLetter - 1;
         set(handles.ModelOutput,'FontSize',OuputLetter);
      end;
    case 2
      if OuputLetter < 20, 
         OuputLetter = OuputLetter + 1;
         set(handles.ModelOutput,'FontSize',OuputLetter);
      end;
end;
return;
% --- Executes on RadioButtons to select the factor model.
function ModelRadius_Callback(gcf, eventdata, handles , radio_value)

    %LOAD DATA
    data=getappdata(0,'data');

    switch radio_value       
        case 1
            set(handles.Model_Linear,'value',1);
            set(handles.Model_TwoParameters,'value',0);
            set(handles.Model_GradedModel,'value',0);
            data.IRTModel=1;
            
        case 2
            set(handles.Model_Linear,'value',0);
            set(handles.Model_TwoParameters,'value',1);
            set(handles.Model_GradedModel,'value',0);
            data.IRTModel=2;

        case 3
            set(handles.Model_Linear,'value',0);
            set(handles.Model_TwoParameters,'value',0);
            set(handles.Model_GradedModel,'value',1);
            data.IRTModel=3;

    end;
    
    %Netejar el color d avis d errors
    set(handles.ModelTextLinear, 'BackgroundColor',[1 1 1],'ForegroundColor',[0 0 0]);
    set(handles.ModelTextTwoParameters, 'BackgroundColor',[1 1 1],'ForegroundColor',[0 0 0]);
    set(handles.ModelTextGradedModel, 'BackgroundColor',[1 1 1],'ForegroundColor',[0 0 0]);
    
    %Fora els resultats actuals
    set(handles.panel_tab3,'visible','off');
%    set(handles.panel_tab4,'visible','off');

    %SAVE DATA 
    setappdata(0,'data',data);

return;
%%%%%%%%%% COMPUTE FUNCTIONS
% --- Executes on button press in ButtonSeleccionarMatriu.
function ButtonCompute_Callback(hObject, eventdata, handles)
% hObject    handle to ButtonData (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
    
    %LOAD DATA
    data=getappdata(0,'data');

    %Clasificar els items com EXCLOSOS, MARKERS i REVERTITS
    [data, error] = GetTypeOfItems(data,handles);
    if error == 1,
        return;
    end;
    
    Xa=data.Xa;
    [N,m]=size(Xa);
    data.N = N; data.m=m;
    
    %Comprovar que tots els items tenen al menys dos valors
    for j=1:m,
        fr=tabulate(Xa(:,j));
        [tmp1,tmp2]=size(fr);
        if (tmp1<2),
           buff = sprintf('Item %.0f is a constant with no variance. This item cannot be included in the analysis.',j);
           msgbox(buff,'AcquiObli','error');
           return; 
        end;
    end;
    
    %Comprovar que al model de dos paramatres els items son dichotomics
    if data.IRTModel == 2,
        for j=1:m,
            fr=tabulate(Xa(:,j));
            [tmp1,tmp2]=size(fr);
            if (tmp1>2),
               set(handles.ModelTextTwoParameters, 'BackgroundColor',[1 0 0],'ForegroundColor',[1 1 1]);
               buff = sprintf('The two parameters model can only computed for dichotomous items.       Item %.0f has %.0f different values.',j,tmp1);
               msgbox(buff,'AcquiObli','error');
               return; 
            end;
        end;
    end;
    set(handles.ModelTextTwoParameters, 'BackgroundColor',[1 1 1],'ForegroundColor',[0 0 0]);

    %Comprovar que al model de Response graded els items no son continuos
    if data.IRTModel == 3,
        tmp3=0;
        for j=1:m,
            fr=tabulate(Xa(:,j));
            [tmp1,tmp2]=size(fr);
            if (tmp1>10),
               set(handles.ModelTextGradedModel, 'BackgroundColor',[1 0 0],'ForegroundColor',[1 1 1]);
               buff = sprintf('The Response graded model can only computed for categoricals items.       Item %.0f has more that 10 categories (%.0f categories). This item is continous, so the graded response model cannot be computed.',j,tmp1);
               msgbox(buff,'AcquiObli','error');
               return; 
            end;
            tmp3=tmp3+tmp1;
        end;
        %%Comprovar si tots els items son dicotomics
        if (tmp3 == m*2),
           set(handles.ModelTextGradedModel, 'BackgroundColor',[1 0 0],'ForegroundColor',[1 1 1]);
           buff = sprintf('The Response graded model should only computed for categoricals items.       For dicotomical items, you must select the Two Parameters Model.');
           msgbox(buff,'AcquiObli','error');
           return; 
        end;
    end;
    set(handles.ModelTextGradedModel, 'BackgroundColor',[1 1 1],'ForegroundColor',[0 0 0]);
    
    %borrar resultats previs
    data = ClearFieldsData(data);
    
    %Activar el panel del Output del model
    set(handles.panel_tab3,'visible','on');
    
    %temps de calcul
    tic_comp = tic; 
    
    PrintPortada(handles.ModelOutput);
    
    %Compute dispersion matrix
    data = ComputeDispersionMatrix(Xa,data);

    PrintAnalysisDetails(data,handles.ModelOutput);
    data = ComputeItemDescriptives(Xa,data,handles.ModelOutput);
    
    data = DispersionMatrixAdecuation(data,handles.ModelOutput);
    
    [tmp, m_aq] = size(data.ItemsMarkers);
    [tmp, m_co] = size(data.ItemsContent);
    rev=data.rev;
    
    if data.IRTModel == 1,
       [P, PHI, RMSRm, RMSRc, RMSRcm, RMSRtot]=acquiobuls(data.R,m_aq,m_co,N,rev);
       data.Res = data.R-(P*PHI*P');
    else,
       [P, PHI, RMSRm, RMSRc, RMSRcm, RMSRtot]=acquiobuls(data.Rp,m_aq,m_co,N,rev);
       data.Res = data.Rp-(P*PHI*P');
    end;

    data.P = P;
    data.PHI = PHI;
    data.RMSRm = RMSRm;
    data.RMSRc = RMSRc;
    data.RMSRcm = RMSRcm;
    data.RMSRtot = RMSRtot;
    PrintModelFitAquiObli(data,handles.ModelOutput);
        
    PrintP(data,handles.ModelOutput);
    PrintPHI(data,handles.ModelOutput);
    
    boot = get(handles.Bootstrap,'value');
    %Acelerated Bootstrap
    if boot == 1,
        CIlevel=0.90;
        if data.IRTModel == 1,
           n_boot=1000;
           [Pb, PHIb, RMSRm_b, RMSRc_b, RMSRcm_b, RMSRtot_b] = BootStrap_acquiobuls (Xa,data.R,data.IRTModel, m_aq,m_co,rev,n_boot,CIlevel,1);
        else,
           n_boot=500;
           [Pb, PHIb, RMSRm_b, RMSRc_b, RMSRcm_b, RMSRtot_b] = BootStrap_acquiobuls (Xa,data.Rp,data.IRTModel, m_aq,m_co,rev,n_boot,CIlevel,1);            
        end;
        PrintP_PHI_BootstrapCI(Pb,PHIb,data,handles.ModelOutput,n_boot,CIlevel);
    end;

    fs = get(handles.FactorScores,'value');
    %Acelerated Bootstrap
    if fs == 1,
        data = ComputeFactorScores(data);
        PrintFactorScores(data,handles.ModelOutput);
    end;
    
    %SAVE DATA 
    setappdata(0,'data',data);
    
    set(gcbf,'Pointer','arrow');
    set(handles.ModelOutput,'value',1');
    
    %computing time
    compT = toc(tic_comp);
    s_tmp=['Computing time = ' Time2String( compT )];
    MyPrint(handles.ModelOutput,' ');
    MyPrint(handles.ModelOutput,s_tmp);
    MyPrint(handles.ModelOutput,' ');
    
    %Activa el Tab dels resultats
    %set(handles.hTabGroup,'SelectedIndex',4);
    tmp=helpdlg(['Job done!' s_tmp '. Go to tab: Output'],'AcquiObli');
    waitfor(tmp);
        
return;
function data = ClearFieldsData(data)

    if (isfield(data, 'R') == 1), data = rmfield(data, 'R'); end;
    if (isfield(data, 'Rp') == 1), data = rmfield(data, 'Rp'); end;
    if (isfield(data, 'thresholds') == 1), data = rmfield(data, 'thresholds'); end;
    if (isfield(data, 'A') == 1), data = rmfield(data, 'A'); end;
    if (isfield(data, 'Res') == 1), data = rmfield(data, 'Res'); end;
    if (isfield(data, 'P') == 1), data = rmfield(data, 'P'); end;
    if (isfield(data, 'PHI') == 1), data = rmfield(data, 'PHI'); end;
    if (isfield(data, 'IRT_A') == 1), data = rmfield(data, 'IRT_A'); end;
    if (isfield(data, 'IRT_B') == 1), data = rmfield(data, 'IRT_B'); end;
    if (isfield(data, 'th') == 1), data = rmfield(data, 'th'); end;
    if (isfield(data, 'th_li') == 1), data = rmfield(data, 'th_li'); end;
    if (isfield(data, 'th_ls') == 1), data = rmfield(data, 'th_ls'); end;
    if (isfield(data, 'se') == 1), data = rmfield(data, 'se'); end;
    if (isfield(data, 'reli') == 1), data = rmfield(data, 'reli'); end;
    if (isfield(data, 'th1') == 1), data = rmfield(data, 'th1'); end;
    if (isfield(data, 'RMSRm') == 1), data = rmfield(data, 'RMSRm'); end;
    if (isfield(data, 'RMSRc') == 1), data = rmfield(data, 'RMSRc'); end;
    if (isfield(data, 'RMSRcm') == 1), data = rmfield(data, 'RMSRcm'); end;
    if (isfield(data, 'RMSRtot') == 1), data = rmfield(data, 'RMSRtot'); end;
    
return;
function MyPrint(Output,NewLine)
        text=get(Output,'string');
        [line,tmp] = size(text);
        text(line+1)=cellstr(NewLine);
        set(Output,'string',text);
return;
function PrintPortada(Output)
    %Netejear el output abans de comenar
    text={};set(Output,'string',text);
    
    MyPrint(Output,' ');
    MyPrint(Output,' ');
    MyPrint(Output,' ');
    MyPrint(Output,'                          A C Q U I O B L I');
    MyPrint(Output,'  ');
    MyPrint(Output,' ');
    MyPrint(Output,'                     Advanced test developer module');
    MyPrint(Output,' ');
    MyPrint(Output,'  ');
    MyPrint(Output,'  ');
    MyPrint(Output,'                         Release Version 1.01');
    MyPrint(Output,'                            December, 2015');
    MyPrint(Output,'  ');
    MyPrint(Output,' ');
    MyPrint(Output,'                 Research Center for Behavior Assessment');
    MyPrint(Output,'  ');
    MyPrint(Output,'                      Universitat Rovira i Virgili');
    MyPrint(Output,'                           Tarragona, SPAIN');
    MyPrint(Output,' ');
    MyPrint(Output,' ');
    MyPrint(Output,['                             ' date]);
    MyPrint(Output,'  ');
    MyPrint(Output,' ');
    MyPrint(Output,'-----------------------------------------------------------------------');
    
return;
function PrintAnalysisDetails(data,Output)
    
    MyPrint(Output,' ');
    MyPrint(Output,'DETAILS OF ANALYSIS');
    MyPrint(Output,' ');
    buff = sprintf('Data file name                     : %s',data.filename); MyPrint(Output, buff);
    buff = sprintf('Number of participants             : %5.0f',data.N); MyPrint(Output, buff);
    buff = sprintf('Number of items                    : %5.0f',data.m); MyPrint(Output, buff);
    [tmp, m_t]=size(data.X);
    [m,tmp]=size(data.ItemsIn);
    if tmp > m,
        m=tmp;
    end;
    if m_t == m,
       MyPrint(Output,'Items included in the analysis     : ALL');
                      
    else,
        buff = 'Items included in the analysis     : ';
        for i=1:m-1,
            buff1=sprintf('%.0f, ',data.ItemsIn(i));
            buff = [buff buff1];
        end;
        buff1=sprintf('%.0f',data.ItemsIn(m));
        buff = [buff buff1];
        MyPrint(Output,buff);
        buff = 'Items excluded in the analysis     : ';
        h=1;
        for i=1:m_t,
            in=0;
            for j=1:m,
                if data.ItemsIn(j) == i,
                    in=1;
                    break;
                end;
            end;
            if in == 0,
               if h==1,
                  buff1=sprintf('%.0f',i);
               else,
                  buff1=sprintf(', %.0f',i);
               end;
               buff = [buff buff1];
               h=2;
            end;
        end;
        MyPrint(Output,buff);

    end;
    
    [tmp, m_aq] = size(data.ItemsMarkers);
    buff = 'Acquiescence marker items          : ';
    for i=1:m_aq-1,
        buff1=sprintf('%.0f, ',data.ItemsMarkers(i));
        buff = [buff buff1];
    end;
    buff1=sprintf('%.0f',data.ItemsMarkers(m_aq));
    buff = [buff buff1];
    MyPrint(Output,buff);
    
    [tmp, m_re] = size(data.ItemsRevertits);
    buff = 'Acquiescence marker items          : ';
    buff = 'Reversed content items             : ';
    for i=1:m_re-1,
        buff1=sprintf('%.0f, ',data.ItemsRevertits(i));
        buff = [buff buff1];
    end;
    buff1=sprintf('%.0f',data.ItemsRevertits(m_re));
    buff = [buff buff1];
    MyPrint(Output,buff);
    
    switch data.IRTModel
        case 1
             MyPrint(Output,'Factor Model                       : LINEAR MODEL');
        case 2
             MyPrint(Output,'Factor Model                       : TWO-PARAMETER NORMAL OGIVE MODEL');
        case 3
             MyPrint(Output,'Factor Model                       : NORMAL-OGIVE GRADED RESPONSE MODEL');
    end;
    
    if (data.R_NPD ==1),
       MyPrint(Output,'WARNING, dispersion matrix was NPD : Smoothing algorithm was applied (XXX)');
    end;
    
    MyPrint(Output,' ');
    MyPrint(Output,'-----------------------------------------------------------------------');
    
return;
function data=ComputeItemDescriptives(X,data,Output)
%     X                 Items
%     LabelsItems    Etiquetes dels items
%     Output            Finestra on imprimir els resultats
    LabelsItems = data.LabelsItems;
    [N,m]=size(X);
    me  = mean(X);
    Sx2 = var(X);
    Skew = skewness(X);
    Kur  = kurtosis(X);
    MyPrint(Output,' ');
    MyPrint(Output,'UNIVARIATE ITEM DESCRIPTIVES');
    MyPrint(Output,' ');
    MyPrint(Output,'Item        Mean        Variance    Skewness     Kurtosis');
    MyPrint(Output,'                                                (Zero centered)');
    MyPrint(Output,' ');
    for i=1:m,
       buff1 = sprintf(' %4.0f      %6.3f      %6.3f',LabelsItems(i),me(i),Sx2(i));
       buff2 = sprintf('      % 6.3f      % 7.3f',Skew(i),Kur(i)-3);
       MyPrint(Output,[buff1 buff2]);
    end;
    MyPrint(Output,' ');
    MyPrint(Output,'-----------------------------------------------------------------------');
    data.mean=me;
    data.Sx2 = Sx2;
    data.Skew = Skew;
    data.Kur = Kur;
    
return
function data = ComputeDispersionMatrix(X,data)

  R=corrcoef(X);
  data.R=R; %PEARSON
  
  switch data.IRTModel
      case 1
          S = cov(X);
          data.R=R; %PEARSON
          data.S=S; %COV
      case {2, 3}
          [Rp,THRES]=polychomap(X,min(X),max(X),3,0,1);
          data.R_NPD = 0;
          %NPD check
          D=eig(Rp);
          if min(D) <0,
             %NONLINEAR TRANSFORMATION
              %Rp = sr(Rp,data.N);
              Rp = R;
              data.R_NPD = 1;
          end;
          data.Rp = Rp; %POLYCHORIC
          data.thresholds = THRES;
  end;     

return
function data = DispersionMatrixAdecuation(data,Output)
    R=data.R;
    N=data.N;
    m=data.m;
    d = det(R);
    %esfericidad_bartlett
    chi = -1.0 * (N - 1 - (2*m + 5)/6 )*log(d);
    df = m*(m-1)/2;
    pro = 1-chi2cdf(chi,df);
  
    %KMO
    kmo_index = kmo(data.Xa);

    data.kmo = kmo_index;
    
    MyPrint(Output,' ');
    MyPrint(Output,'ADEQUACY OF THE DISPERSION MATRIX');
    MyPrint(Output,' ');
    buff = sprintf('Determinant of the matrix     = %17.15f',d);
    MyPrint(Output,buff);
    buff = sprintf('Bartlett''s statistic          = %7.1f (df = %5.0f; P = %7.6f)',chi,df,pro);
    MyPrint(Output,buff);
    buff1 = sprintf('Kaiser-Meyer-Olkin (KMO) test = %7.5f ',kmo_index);
    if     (kmo_index >= 0.9), buff2 = sprintf('(very good)');
    elseif (kmo_index >= 0.8), buff2 = sprintf('(good)');
    elseif (kmo_index >= 0.7), buff2 = sprintf('(fair)');
    elseif (kmo_index >= 0.6), buff2 = sprintf('(mediocre)');
    elseif (kmo_index >= 0.5), buff2 = sprintf('(bad)');
    else,                      buff2 = sprintf('(inaceptable)');    
    end;
    MyPrint(Output,[buff1 buff2]);
    MyPrint(Output,' ');
    MyPrint(Output,'-----------------------------------------------------------------------');
    
return

function PrintModelFitAquiObli(data,Output)
    MyPrint(Output,' ');
    MyPrint(Output,'GOODNESS OF FIT STATISTICS (RMSR)');
    MyPrint(Output,' ');
    buff = sprintf('Fit of the marker sub-model               = % 7.4f',data.RMSRm);
    MyPrint(Output,buff);
    buff = sprintf('Fit of the content sub-model              = % 7.4f',data.RMSRc);
    MyPrint(Output,buff);
    buff = sprintf('Fit of the content-acquiescence sub-model = % 7.4f',data.RMSRcm);
    MyPrint(Output,buff);
    buff = sprintf('Fit of the overall model                  = % 7.4f',data.RMSRtot);
    MyPrint(Output,buff);
    MyPrint(Output,' ');
    MyPrint(Output,'-----------------------------------------------------------------------');

return;
function data = PrintModelFit(data,Output)

    switch data.IRTModel
        case 1
           R=data.R;
           Re=data.Res;
        case{2,3}
           R=data.Rp;
           Re=data.Re;
    end;
    m=data.m;
    N=data.N;
    
    %GFI
    tmp1=0;tmp2=0;
	for i=1:m,
	    for j=1:m,
 			 tmp1 = tmp1 + (Re(i,j)*Re(i,j));
 			 tmp2 = tmp2 + (R(i,j)*R(i,j));
        end;
    end;
    GFI = tmp1 / tmp2;
    data.GFI = GFI;
    
    %RMSR
     A=zeros(m*(m-1)/2,1);
     h = 1;
     for i=1:m,
 	   for j=(i+1):m,
          A(h,1)= R(j,i) - Re(j,i);
          h=h+1;
       end;
     end;

     me = mean(A);
     sd = std(A);
     RMSR = sqrt(sd*sd+me*me);
     se = sqrt(1/(N-1));
     
     data.RMSR = RMSR;
     data.Kelley = se;
     
    MyPrint(Output,' ');
    MyPrint(Output,'GOODNESS OF FIT STATISTICS');
    MyPrint(Output,' ');
    buff = sprintf('                        Goodness of Fit Index (GFI) = %7.4f',GFI);
    MyPrint(Output,buff);
    buff = sprintf('               Root Mean Square of Residuals (RMSR) = % 7.4f',RMSR);
    MyPrint(Output,buff);
    buff = sprintf('Expected mean value of RMSR for an acceptable model = % 7.4f (Kelley''s criterion) (Kelley, 1935,page 146; see also Harman, 1962, page 21 of the 2nd edition)',se);
    MyPrint(Output,buff);
    MyPrint(Output,' ');
    if RMSR > se,
       MyPrint(Output,'Note: if the value of RMSR is much larger than Kelley''s criterion value the model cannot be considered as good');
       MyPrint(Output,' ');  
    end;
    MyPrint(Output,'DISTRIBUTION OF RESIDUALS');
    MyPrint(Output,' ');
    buff = sprintf('Smallest Fitted Residual = % 7.4f',min(A));
    MyPrint(Output,buff);
    buff = sprintf('  Median Fitted Residual = % 7.4f',median(A));
    MyPrint(Output,buff);
    buff = sprintf(' Largest Fitted Residual = % 7.4f',max(A));
    MyPrint(Output,buff);
    buff = sprintf('    Mean Fitted Residual = % 7.4f',me);
    MyPrint(Output,buff);
    buff = sprintf('Variance Fitted Residual = % 7.4f',sd*sd);
    MyPrint(Output,buff);
    MyPrint(Output,' ');
    MyPrint(Output,'-----------------------------------------------------------------------');
    
return;
function [data, error] = GetTypeOfItems(data,handles)

    error = 1;
    [N,m]=size(data.X);

    set(handles.Marcadors, 'BackgroundColor',[1 1 1],'ForegroundColor',[0 0 0]);
    set(handles.Exclosos, 'BackgroundColor',[1 1 1],'ForegroundColor',[0 0 0]);
    set(handles.Revertits, 'BackgroundColor',[1 1 1],'ForegroundColor',[0 0 0]);
    
    
     %AGAFA ITEMS EXCLOSOS
     tmp = get(handles.Exclosos,'string');
     if isempty(tmp),
        ItemsEX=[];
        ItemsIN=[1:m];
     else;
        ItemsEX=floor(sort(str2num(tmp)));
        if isempty(ItemsEX),
          set(handles.Exclosos, 'BackgroundColor',[1 0 0],'ForegroundColor',[1 1 1]);  
          msgbox('I do not understand the indices of the items excluded from the analysis','AcquiObli','error');
          return;
        end;
        if min(ItemsEX) < 1,
          set(handles.Exclosos, 'BackgroundColor',[1 0 0],'ForegroundColor',[1 1 1]); 
          msgbox('Indices of excluded items have to be numbers larger than zero','AcquiObli','error');
          return;
        end;
        if max(ItemsEX) > m,
          set(handles.Exclosos, 'BackgroundColor',[1 0 0],'ForegroundColor',[1 1 1]);   
          msgbox('Indices of excluded items  cannot be larger than the number of items','AcquiObli','error');
          return;
        end;
        [tmp1,tmp2]=size(ItemsEX);
        if (m - tmp2) < 7,
          set(handles.Exclosos, 'BackgroundColor',[1 0 0],'ForegroundColor',[1 1 1]);   
          msgbox('At least three markers of acquiescence and four items of content are needed','AcquiObli','error');
          return;
        end;        
        ItemsIN=[];
        for j=1:m,
            campana = 0;
            for i=1:tmp2,
                if j == ItemsEX(i),
                    campana = 1;
                end;
            end;
            if campana == 0,
                ItemsIN = [ItemsIN j];
            end;
        end;

     end;

     %AGAFA MARKER ITEMS
     ItemsMarkers=[];
     ItemsContent=[];

     tmp = get(handles.Marcadors,'string');
     if isempty(tmp),
          set(handles.Marcadors, 'BackgroundColor',[1 0 0],'ForegroundColor',[1 1 1]);  
          msgbox('At least three items should be markers of acquiescence','AcquiObli','error');
          return;
     else;
        ItemsMarkers=floor(sort(str2num(tmp)));
        if isempty(ItemsMarkers),
          set(handles.Marcadors, 'BackgroundColor',[1 0 0],'ForegroundColor',[1 1 1]);  
          msgbox('I do not understand the indices of the items selected as markers of acquiescence','AcquiObli','error');
          return;
        end;
        if min(ItemsMarkers) < 1,
          set(handles.Marcadors, 'BackgroundColor',[1 0 0],'ForegroundColor',[1 1 1]); 
          msgbox('Indices of markers of acquiescence have to be numbers larger than zero','AcquiObli','error');
          return;
        end;
        if max(ItemsMarkers) > m,
          set(handles.Marcadors, 'BackgroundColor',[1 0 0],'ForegroundColor',[1 1 1]);   
          msgbox('Indices of markers of acquiescence  cannot be larger than the number of items','AcquiObli','error');
          return;
        end;
        [tmp1,tmp2]=size(ItemsMarkers);
        if tmp2 < 3,
          set(handles.Marcadors, 'BackgroundColor',[1 0 0],'ForegroundColor',[1 1 1]);   
          msgbox('At least three items should be markers of acquiescence','AcquiObli','error');
          return;
        end;      
        
        [tmp,m_ex] = size(ItemsEX);
        for j=1:m_ex,
            campana = 0;
            for i=1:tmp2,
                if ItemsEX(j) == ItemsMarkers(i),
                    campana = 1;
                end;
            end;
            if campana == 1,
                set(handles.Exclosos, 'BackgroundColor',[1 0 0],'ForegroundColor',[1 1 1]);   
                msgbox('An excluded item cannot be used as a marker of acquiescence','AcquiObli','error');
                return;
            end;
        end;
        
        [tmp,m_ma] = size(ItemsMarkers);
        [tmp,m_in] = size(ItemsIN);
        if (m_in - m_ma) < 4,
          set(handles.Marcadors, 'BackgroundColor',[1 0 0],'ForegroundColor',[1 1 1]);   
          msgbox('At least four items of content are needed','AcquiObli','error');
          return;
        end;        
        for j=1:m_in,
            campana = 0;
            for i=1:m_ma,
                if ItemsIN(j) == ItemsMarkers(i),
                    campana = 1;
                end;
            end;
            if campana == 0,
                ItemsContent = [ItemsContent ItemsIN(j)];
            end;
        end;
        [tmp1,tmp2]=size(ItemsContent);
        if tmp2 < 4,
          set(handles.Exclosos, 'BackgroundColor',[1 0 0],'ForegroundColor',[1 1 1]);   
          msgbox('At least four items of content are needed','AcquiObli','error');
          return;
        end;       
     end;

     %AGAFA ITEMS DE CONTINGUT REVERTITS
     ItemsREV=[];
     tmp = get(handles.Revertits,'string');
     if isempty(tmp),
        set(handles.Revertits, 'BackgroundColor',[1 0 0],'ForegroundColor',[1 1 1]);   
        msgbox('Half of the content items have to be reversed','AcquiObli','error');
        return;
     else;
        ItemsRevertits=floor(sort(str2num(tmp)));
        if isempty(ItemsRevertits),
          set(handles.Revertits, 'BackgroundColor',[1 0 0],'ForegroundColor',[1 1 1]);  
          msgbox('I do not understand the indices of the items that are reversed from the analysis','AcquiObli','error');
          return;
        end;
        if min(ItemsRevertits) < 1,
          set(handles.Revertits, 'BackgroundColor',[1 0 0],'ForegroundColor',[1 1 1]); 
          msgbox('Indices of the items that are reversed have to be numbers larger than zero','AcquiObli','error');
          return;
        end;
        if max(ItemsRevertits) > m,
          set(handles.Revertits, 'BackgroundColor',[1 0 0],'ForegroundColor',[1 1 1]);   
          msgbox('Indices of the items that are reversed cannot be larger than the number of items','AcquiObli','error');
          return;
        end;
        
        [tmp1,m_re]=size(ItemsRevertits);
        for j=1:m_ex,
            campana = 0;
            for i=1:m_re,
                if ItemsEX(j) == ItemsRevertits(i),
                    campana = 1;
                end;
            end;
            if campana == 1,
                set(handles.Exclosos, 'BackgroundColor',[1 0 0],'ForegroundColor',[1 1 1]);   
                msgbox('An excluded item cannot be used as reversed items','AcquiObli','error');
                return;
            end;
        end;        
        for j=1:m_ma,
            campana = 0;
            for i=1:m_re,
                if ItemsMarkers(j) == ItemsRevertits(i),
                    campana = 1;
                end;
            end;
            if campana == 1,
                set(handles.Marcadors, 'BackgroundColor',[1 0 0],'ForegroundColor',[1 1 1]);   
                msgbox('Items selected as marquers cannot be used as reversed items','AcquiObli','error');
                return;
            end;
        end;        
        
        [tmp1,m_co]=size(ItemsContent);
        if (m_co - m_re) ~= floor(m_re),
          set(handles.Revertits, 'BackgroundColor',[1 0 0],'ForegroundColor',[1 1 1]);   
          msgbox('Half of the content items have to be reversed','AcquiObli','error');
          return;
        end;        
 
     end;
   
    %Recogir les dades: SD + CONTENT ITEMS
    Xa = data.X(:,[ItemsMarkers ItemsContent] );
    for i=1:m_ma,
        buff=sprintf('%3.0f m',ItemsMarkers(i));
        data.LabelsItemsString{i}=cellstr(buff) ;
    end;
    rev =[];
    for i=1:m_co,
        campana=0;
        for j=1:m_re,
            if ItemsContent(i) == ItemsRevertits(j),
                campana=1;
            end;
        end;
        if campana == 1,
            rev=[rev i];
            buff=sprintf('%3.0f -',ItemsContent(i));
            data.LabelsItemsString{m_ma+i}=cellstr(buff) ;
        else,
            buff=sprintf('%3.0f +',ItemsContent(i));
            data.LabelsItemsString{m_ma+i}=cellstr(buff) ;
        end;
    end;
    data.Xa=Xa;
    
    %Index dels items de contingut revertits segons la seva posici a l'anlisi entre els items de contingut
    data.rev = rev;
    
    %Etiquetes numeriques
    data.LabelsItems=[ItemsMarkers ItemsContent];

    data.ItemsIn=ItemsIN;
    data.ItemsEx=ItemsEX;
    data.ItemsMarkers=ItemsMarkers ;
    data.ItemsRevertits=ItemsRevertits;
    data.ItemsContent=ItemsContent;
    
    error = 0;
    return;
function PrintPHI(data,Output)

    MyPrint(Output,' ');
    MyPrint(Output,'CORRELATION MATRIX BETWEEN CONTENT AND ACQUIESCENCE FACTORS');
    MyPrint(Output,' ');
    
    [r,r]=size(data.PHI);
    
    %labels
    buff = 'Factor        ';
    for i=1:r,
        buff1=sprintf('    F%2.0f     ',i);
        buff =[ buff buff1];
    end;
    MyPrint(Output,buff);
    %matriu
    for i=1:r,
        buff=sprintf('        F %2.0f     ',i);
        for j=1:i,
             buff1=sprintf('% .3f      ',data.PHI(i,j));
            buff = [buff buff1];
        end;
        MyPrint(Output,buff);
    end;
   
    MyPrint(Output,' ');
    MyPrint(Output,'-----------------------------------------------------------------------');
return
    
function PrintP(data,Output)

    MyPrint(Output,' ');
    MyPrint(Output,'PATTERN LOADING MATRIX FOR CONTENT AND ACQUIESCENCE FACTORS');
    MyPrint(Output,' ');
    
    [m,r]=size(data.P);

    %labels
    buff = '        Item        CONTENT     AQ';

    MyPrint(Output,buff);
    %matriu
    for i=1:m,
        buff=sprintf('        %6s     ',char(data.LabelsItemsString{i}));
        for j=1:r,
            buff1=sprintf('% .3f      ',data.P(i,j));
            buff = [buff buff1];
        end;
        MyPrint(Output,buff);
    end;
   
    MyPrint(Output,' ');
    MyPrint(Output,'-----------------------------------------------------------------------');
return
function PrintP_PHI_BootstrapCI(Pb, PHIb,data, Output ,n_boot,CIlevel)
         
    MyPrint(Output,' ');
    MyPrint(Output,'BOOTSTRAP CONFIDENCE INTERVALS FOR LOADINGS AND INTER-FACTOR CORRELATION VALUES');
    MyPrint(Output,' ');
    buff=sprintf('Bootstrap method   :   Accelerated Bootstrap');
    MyPrint(Output,buff);
    buff=sprintf('Bootstrap samples  :  %4.0f',n_boot);
    MyPrint(Output,buff);
    buff=sprintf('Confidence interval:  %4.0f%%',CIlevel*100);
    MyPrint(Output,buff);
    MyPrint(Output,' ');
    
    [m,r]=size(data.P);
    [tmp,m_ma] = size(data.ItemsMarkers);
    %labels
    MyPrint(Output,' ');
    buff = '       CONTENT FACTOR';
    MyPrint(Output,buff);
    MyPrint(Output,' ');
    buff = '       Item      CONTENT     Lower       Upper';
    MyPrint(Output,buff);
    %matriu
    for i=m_ma+1:m,
        buff=sprintf('        %3.0f     ',data.LabelsItems(i));
        buff1=sprintf('% .3f      % .3f      % .3f      ',data.P(i,1),Pb(i,1),Pb(i,2));
        buff = [buff buff1];
        MyPrint(Output,buff);
    end;

    MyPrint(Output,' ');
    buff = '       ACQUIESCENCE FACTOR';
    MyPrint(Output,buff);
    MyPrint(Output,' ');
    buff = '       Item      AQ          Lower       Upper';
    MyPrint(Output,buff);
    %matriu
    for i=1:m,
        buff=sprintf('       %6s   ',char(data.LabelsItemsString{i}));
        buff1=sprintf('% .3f      % .3f      % .3f      ',data.P(i,2),Pb(m+i,1),Pb(m+i,2));
        buff = [buff buff1];
        MyPrint(Output,buff);
    end;
    MyPrint(Output,' ');
    buff = '       INTER-FACTOR CORRELATION';
    MyPrint(Output,buff);
    MyPrint(Output,' ');
    buff = '                 PHI         Lower       Upper';
    MyPrint(Output,buff);
    buff=sprintf('                % .3f      % .3f      % .3f      ',data.PHI(1,2),PHIb(1),PHIb(2));
    MyPrint(Output,buff);
    
    MyPrint(Output,' ');
    MyPrint(Output,'-----------------------------------------------------------------------');
return

function data = ComputeFactorScores(data)
 
   [m,r] = size(data.P);

   P = data.P;
   X = data.Xa - min(min(data.Xa)') + 1;
   PHI = data.PHI;
   
   switch data.IRTModel
        %Linear Model
        case 1
            [th,th_li,th_ls,se,reli] = eap_continuous_obli(X,P,PHI);

        %Ordinal Models
        case {2,3}
             THRES = data.thresholds;
             THRES = [THRES zeros(m,1)]';
             sigj = diag(sqrt( diag(diag(data.Rp - P*PHI*P'))));
             [th,th_li,th_ls,se,reli] = reap_grad_obli(X, P, PHI, THRES, sigj,1);

    end;
    data.th=th;
    data.th_li=th_li;
    data.th_ls=th_ls;
    data.se=se;
    data.reli=reli;

return

function PrintFactorScores(data,Output)
    
    [m,r] = size(data.P);
    N=data.N;
 
    TotalLines = N*r;
    
    BarCount = 0; bar1 = waitbar(BarCount,'Printing ... ');
    TicPrint = tic;

    MyPrint(Output,' ');
    MyPrint(Output,' ');
    switch data.IRTModel
            case {1}
                    MyPrint(Output,'CONTINUOUS EAP FACTOR SCORES ESTIMATES AND PRECISION'); 
            case {2,3}    
                    MyPrint(Output,'GRADED EAP FACTOR SCORES ESTIMATES AND PRECISION'); 
    end;
    MyPrint(Output,' ');
    MyPrint(Output,' ');
    
    th = data.th;
    se = data.se;
    th_li=data.th_li;
    th_ls=data.th_ls;
    reli=data.reli;
    
    for j=1:r,
        if (j==1),
            buff=sprintf('FACTOR: CONTENT      ');
        else,
            buff=sprintf('FACTOR: ACQUIESCENCE      ');
        end;
        MyPrint(Output,buff);
        MyPrint(Output,' ');

        switch data.IRTModel
            case {1}
                  buff=sprintf('RELIABILITY OF EAP FACTOR SCORES:   % .3f          ',reli(j));
                  MyPrint(Output,buff);
                  MyPrint(Output,' ');
                  MyPrint(Output,'Participant  Estimate      Approximate 90%      Posterior');
            case {2,3}    
                  buff=sprintf('RELIABILITY OF EAP FACTOR SCORES:   % .3f          ',mean(reli(:,j)));
                  MyPrint(Output,buff);
                  MyPrint(Output,' ');
                  MyPrint(Output,'Participant  Estimate      Approximate 90%      Posterior  Reliability');
        end;
        MyPrint(Output,'             factor score  confidence interval  SD (PSD)');
                                                               
        MyPrint(Output,' ');
        for i=1:N,

            buff=sprintf('%4.0f         % .3f        ',i,th(i,j));
            buff1=sprintf('(% .3f   % .3f)   ',th_li(i,j),th_ls(i,j));
            switch data.IRTModel
                case {1}
                      buff2=sprintf('% .3f       ',se(j,j));
                case {2,3}    
                      buff2=sprintf('% .3f      % .3f',se(i,j),reli(i,j));
            end;

            buff =[ buff buff1 buff2];
            MyPrint(Output,buff);

            %Bar
            BarCount = BarCount + 1; 
            compT = toc(TicPrint);
            compT = compT*(TotalLines-BarCount)/BarCount;
            s_tmp=['Printing ... (Remaining time = ' Time2String( compT ) ')'];
            waitbar(BarCount/TotalLines,bar1,s_tmp);

        end;
        MyPrint(Output,' ');
        if j<r,
           MyPrint(Output,'-----------------------------------------------------------');
           MyPrint(Output,' ');
        end;
        
    end;

    close(bar1);
    
    MyPrint(Output,' ');
    MyPrint(Output,'-----------------------------------------------------------------------');

return;

